;
;*******************************************************************************
; Hardware Zuweisungen zu Handencoder
;*******************************************************************************
;
;Der Handencoder ist an PC0 ( A ), PC1 ( B ), PD7 ( Taster ) angeschlossen.
;Fuer die Motordrehrichtung ueber die L298N-Platine sind PD2=INH_1, PD3=PWM,
;PD4=INH_2 angeschlossen. Das heisst PD3 an ENB, PD2 an IN4, PD4 an IN3.
;
.EQU XTAL		  = 20000000 ;1843200  ;Quarzfrequenz in Hertz
;
;Ausgabe Port
;
.EQU OUT_PIN	  = PINB    ;Eingabeport 
.EQU OUT_DDR	  = DDRB    ;Datenrichtungsregister 
.EQU OUT_PORT     = PORTB   ;Ausgabeport  
;.EQU out.oc2a     = PB3     ;Pinn 17 fuer PWM-Signal A ( OC2A )
;
;Drehgeber 
;
.EQU DRG_PIN      = PINC     ;Eingabeport an dem der Drehgeber angeschlossen ist
.EQU DRG_DDR      = DDRC     ;Datenrichtungsregister 
.EQU DRG_PORT     = PORTC    ;Ausgabeport 
.EQU drg.a        = PC1      ;Pin Drehgeber SpurA
.EQU drg.b        = PC0      ;Pin Drehgeber SpurB
.EQU drg.stop	  = PC3		 ;Pin Anzeige Drehgeber stop

.EQU PLA_PIN      = PINC     ;Eingabeport 
.EQU PLA_DDR      = DDRC     ;Datenrichtungsregister 
.EQU PLA_PORT     = PORTC    ;Ausgabeport 
.EQU pla.led      = PC2      ;Pin an dem die PLA-LED angeschlossen ist


.EQU LED_PIN      = PIND     ;Eingabeport 
.EQU LED_DDR      = DDRD     ;Datenrichtungsregister 
.EQU LED_PORT     = PORTD    ;Ausgabeport  
.EQU led.in_1	  = PD2		 ;Pin fuer die Anzeige der Richtung ( IN_1 )
.EQU led.in_2	  = PD4		 ;Pin fuer die Anzeige der Richtung ( IN_2 )

.EQU KEY_PIN	  = PIND     ;Eingabeport an dem der Taster angeschlossen ist
.EQU KEY_DDR	  = DDRD     ;Datenrichtungsregister fuer den Taster
.EQU KEY_PORT	  = PORTD    ;Port fuer die Pull-up Widerstand-Aktivierung
.EQU key.pin	  = PD7      ;Pin an dem der Taster angeschlossen ist

.EQU PWM2B_PIN    = PIND    ;Eingabeport 
.EQU PWM2B_DDR    = DDRD    ;Datenrichtungsregister fuer OC2B
.EQU PWM2B_PORT   = PORTD   ;Ausgabeport fuer OC2B
.EQU pwm2b.oc2b   = PD3     ;Pinn 5 fuer PWM-Signal B ( OC2B )


