; 
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Timer0 Overflow ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_OVF0addr:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 
;
;Tasterentprellung. Das Bit key.actuated ( Taster betaetigt & entprellt )
;wird nach dem Auswerten in der Hauptprogrammschleife rueckgesetzt.
;
 bst  key_reg,key.unactuated;Taster betaetigt & entprellt im T-Flag speichern 
 sbis KEY_PIN,key.pin       ;Taster unbetaetigt?
 rjmp _actuated             ;Nein => Taster betaetigt
 brts _counterrestore       ;Zaehler auf 4 ruecksetzen
 rjmp _count                ;Bis 3 Zaehlen
_actuated:
 brts _count                ;Weiter von 5 bis 8 zaehlen
_counterrestore:
 cbr  key_reg,$03           ;Zaehlerbits 1&0 ruecksetzen
_count:
 sbrs key_reg,key.actuated  ;Taster betaetigt entprellt?
 inc  key_reg   
;
;Handencoder ( Drehgeber ) bearbeiten. 
;
 in   ia,DRG_PIN		    ;Neuen Drehgeberwert einlesen und..
 andi ia,drg_msk		    ;..fuer die Weiterverarbeitung Spur A & B selektieren
 lsl  drg_merker		    ;Schieben, um mit dem vorherigen Zustand..
 lsl  drg_merker		    ;..vergleichen zu koennen..
 andi drg_merker,drg_cpi    ;..relevanten Bereich f. das Vergleichen selektieren..
 or   drg_merker,ia		    ;..und fuer Vergleich formatieren
 cpi  drg_merker,drg_r1     ;Erste Moeglichkeit f. Rechts?
 breq _drg_rechts	        ;JA -> Flag f. Rechts setzen
 cpi  drg_merker,drg_r2     ;Zweite Moeglichkeit f. Rechts?
 breq _drg_rechts	        ;JA -> Flag f. Rechts setzen
 cpi  drg_merker,drg_l1     ;Erste Moeglichkeit f. Links ?
 breq _drg_links	        ;JA -> Flag f. links setzen
 cpi  drg_merker,drg_l2     ;Zweite Moeglichkeit f. Links ?
 breq _drg_links		    ;JA -> Flag f. links setzen
 rjmp _pla				    ;Bei der PLA-Routine weitermachen und ISR verlassen

_drg_rechts: 
 sbr  flag_reg,1<<drg.rechts;Anzeigen das der Drehgeber rechst gedreht wurde
 rjmp _pla				    ;Bei der PLA-Routine weitermachen und ISR verlassen
 
_drg_links:
 sbr  flag_reg,1<<drg.links	;Anzeigen das der Drehgeber links  gedreht wurde
;
;ProgrammLaufAnzeige-LED ( PLA-LED ) blinken lassen 
;
_pla: 
 sbrs flag_reg,pla.flg      ;PLA-Flag in der Mainschleife quitiert?...
 rjmp _exit_OVF0addr        ;...Nein => ISR verlassen

 inc  ovf0_zlr              ;Overflowzlr inkrementieren...
 sbrs ovf0_zlr,#ovf0_zlr    ;...bis 32 gezaehlt...
 rjmp _exit_OVF0addr        ;...Nein => ISR verlassen
 clr  ovf0_zlr              ;Overflowzaehler ruecksetzen

 sbi  PLA_PIN, pla.led      ;Programmlaufanzeige LED toggeln
;
;Timer0 Overflow ISR verlassen
; 
_exit_OVF0addr:             ;Timer0 Overflow Interrupt verlassen
 cbr flag_reg,1<<pla.flg    ;Programmlaufanzeige-Flag quitieren
 
 out  SREG,s_sreg           ;Statusregister wiederherstellen
 
 reti                       ;Ruecksprung aus der Timer0 Overflow ISR
