;
.include "Header.inc"       ;Label und Werte Zuweisungen
.include "Hardware.inc"     ;Hardware Label  Zuweisungen
;
;Programmstart nach RESET  ( Interrupt Vektoren Tabelle )
;
.CSEG                       ;Was ab hier folgt kommt in den FLASH-Speicher
.ORG $0000                  ;Programm beginnt an der FLASH-Adresse 0x0000..
 rjmp  _reset               ;..mit der RESET-Vectortabelle

.include "IRQm88PA.inc"     ;Restliche Interrupt Vektortabelle

.ORG INT_VECTORS_SIZE       ;Programmadresse nach den ganzen IRQ-Vektoren
;
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;K Konstanten im Flash 
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;
;.DB 
;
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;I Erstinitialisierungen
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;
;Stapelzeiger initialisieren (fuer Unterprogramme und / oder Interrupts)
;
_reset:
 ldi  a,High(RAMEND)        ;RAMEND, also das Ende vom SRAM, ist in der.. 
 out  SPH,a                 ;..Definitions-datei festgelegt  
 ldi  a,Low (RAMEND)
 out  SPL,a
;
;Variablen initialisieren ( r0-r31 haben unbestimmten Inhalt )
;
 clr  null                  ;Register mit dem Wert Null
 ldi  a,#sk6812_helligkeit  ;Register mit diesem Pixelhelligkeitswert..
 mov  eins,a                ;..laden
; clr  null_low              ;..belegen
 ;clr  key_reg               ;Tasterentprellregister
 clr  flag_reg              ;Allgemeines Flaggenregister;
 clr  ovf0_zlr              ;Timer0 Overflow-Zaehler initialisieren
 clr  ovf2_zlr              ;Timer2 Overflow-Zaehler initialisieren
 clr  xh                    ;SK6812 Uebernahmesignallaenge ( Reset )..
 clr  xl                    ;..vorbereiten
 clr  pixaus_zlr            ;SK6812 Pixelauszaehler ( Nullen zaehler )
 clr  yh
 clr  yl
 
 ser  ia
 ;clr  mwn                   ;Messwert..
 ;clr  mwl                   ;..erstmal..
 ;clr  mwh                   ;..auf Null

 ;ldi  xl,1
 ;clr  xh

 ;clr  z_adc_addition        ;ADC-Aditionszaehler auf eins setzen, um 256..

;
;Ports Erstkonfiguration
; 
 sbi  PLA_PORT,led.pla      ;PraogrammLaufAnzeige-LED aus ( Vorerst Pullup )
 sbi  PLA_DDR, led.pla      ;PORT-Bit als Ausgang f. PLA-LED ( Jetzt High )
 
 ;sbi  PLA_PORT,led.err      ;Error-LED ausschalten ( Vorerst Pullup )
 ;sbi  PLA_DDR, led.err      ;PORT-Bit als Ausgang f. Error-LED ( Jetzt High )
  
 sbi  DIN_DDR,din.bit       ;SK6812 DIN auf Anfangspegel setzen ( IDLE ) 
 sbi  DIN_DDR,din.help      ;Hilfs-Pin um SK6812 DIN zu analysieren

 ;sbi  LED_PORT,led.ok       ;OK-LED ausschalten ( Vorerst Pullup )
 sbi  LED_DDR, led.ok       ;PORT-Bit als Ausgang f. OK-LED ( Jetzt High )

; sbi  KEY_PORT,key.bit      ;Pullup f. Taster einschalten
 sbi  KEY_PORT,jmp.pla     ;Pullup f. Jumper PLA einschalten
;
; USART Baudrate einstellen
;
 ldi  a,#ubrr               ;Fuer UBRRH & UBRRL bei 38400 Baud..
 sts  UBRR0H,null           ;..mit 20MHz..
 sts  UBRR0L,a              ;..Quarz
;
;USART Format ( 8,N,1 ) ist bereits nach dem Reset voreingestellt, aber um die
;9600 Baud zu erreichen muss U2X0 ( Double the USART Transmission Speed ) ein-
;geschaltet werden. 
;
 ldi  a,1<<U2X0             ;Double the USART Transmission Speed..
 sts  UCSR0A,a              ;..einstellen, um 38400 Baud mit 0,2% zu erzielen
;
;USART Sendeschieberegisterinterrupt und Sender ( Transmitter ) freigeben
;
 ldi  a,1<<TXEN0  ;USART Sendeschieberegisterinterrupt freigeben...1<<TXCIE0|
 sts  UCSR0B,a              ;...und USART-Sendeeinheit einschalten
;
;Timer/Counter0 Overflow Interrupt initialisieren
;
 ldi  a,1<<TOIE0            ;Timer0 Overflow Interrupt freigeben...
 sts  TIMSK0,a              ;...
 ldi  a,1<<CS02|1<<CS00     ;Timer0 Vorteiler => 1024...
 out  TCCR0B,a              ;...
;
;Timer/Counter2 Overflow Interrupt initialisieren
;
 ldi  a,1<<TOIE2            ;Timer2 Overflow Interrupt freigeben...
 sts  TIMSK2,a              ;...
 ldi  a,0<<CS22|1<<CS21|0<<CS20;Timer0 Vorteiler => 8...
 sts  TCCR2B,a              ;...
;
;Timer/Counter2: Fast PWM-Mode ( 7 ) initialisieren, NON-INVERT, 
;ohne Vorteiler. Clear OC2B on Compare Match, set OC2B on TOP. 
;OC2B ist der PWM-Pinn, da OCR2A ja den TOP-Wert enthlt.
;Der OC2A-Pinn ist auf Toggeln eingestellt und hat die halbe Frequenz.
;TOV2-ISR bei TOP.
;
 /*ldi  a,#fpwm_freq          ;800kHz an OC2B einstellen,..
 sts  OCR2A,a               ;..
 lsr  a                     ;..und Puls,-Pausenverhaeltnis..
 sts  OCR2B,a               ;..50& einstellen.

 ldi  a,NINV0B|1<<WGM21|1<<WGM20;Fast PWM-Mode 7..
 sts  TCCR2A,a              ;..clear OC2B on Compare Match,..
 ldi  a,1<<CS20|1<<WGM22    ;...set OC2B on TOP, ohne Vor-..
 sts  TCCR2B,a              ;..teiler, Timer/Counter2 starten und..
 sbi  PWM2B_DDR,OC2B         ;..PWM-Portpinn als Ausgang  freigeben
*/;
;ADC Erstwandlung im Free Running Mode. Danach Einzelwandlungen mit ADC-ISR.
;10-Bit, Aref=AVcc, 115200 Hz, digitale Eingangspuffer alle abschalten 
;
 ldi  a,$3F                 ;Alle digitalen Eingangspuffer abschalten..
 sts  DIDR0,a               ;..(PC0-5), um die Leistungsaufnahme zu reduzieren

 ldi  a,1<<REFS0            ;Aref = AVcc.. 
 sts  ADMUX,a               ;..mit 100nF am Aref-Pin

 ;ldi  a,1<<ADEN|1<<ADSC|1<<ADATE|1<<ADIE|1<<ADPS2;ADC Freigeben, Erstwandlung starten,..
 ;sts  ADCSRA,a              ;..Free Running Mode und Vorteiler auf 16 
 
 ldi   a,1<<ADEN|1<<ADSC|1<<ADIF|1<<ADIE|1<<ADPS2;Einzelwandlung mit ADC-ISR..
 sts   ADCSRA,a             ;..starten

 ;sei                        ;Globale Interruptfreigabe im CPU-Statusregister
;
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;H Hauptprogrammschleife
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;
_main:
 sbic KEY_PIN,jmp.pla         ;Jumper PLA-Aktiv gesteckt?
 cbr  flag_reg,1<<pla.aktiv   ;NEIN -> Flag PLA-Aktiv ruecksetzen ( deaktivieren )
 sbis KEY_PIN,jmp.pla         ;Jumper PLA-Aktiv gesteckt?
 sbr  flag_reg,1<<pla.aktiv   ;JA ->   Flag PLA-Aktiv setzen

 rjmp _sk6812_loop            ;Nachfolgenden Einschub ueberspringen
;
;Uebernahmesignal erzeugen ( Reset )
; 
_sk6812_reset:
 nop                       ;Timing anpassen
 sbi  DIN_PORT,din.bit     ;Ende der L-Phase vom letztem Bit
 cbi  DIN_PORT,din.bit     ;Reset vorbereiten
 clr  xh
 clr  xl
_sk6812_reset_wait: 
 sbiw xh:xl,1
 ldi  c_temp,high(#cp2)
 cpi  xl    , low(#cp2)
 cpc  xh    , c_temp 
 brne _sk6812_reset_wait
 
 nop                       ;Auf 80,000s trimmen

_sk6812_wait:              ;####################################################
 sbiw yh:yl,1              ;
 brne _sk6812_wait         ; T E S T 
 inc  ia
 cpi  ia,30
 brne _sk6812_wait
 ser  ia 
 ;clr  ia                   ;####################################################


 tst  sk6812_step          ;T E S T ############################################
 breq _sk6812_loop         ;Alle Schritte abgearbeitet? JA -> Ablauf fertig 
 dec  sk6812_step          ;Sk6812 Ablaufschrittzaehler um eins vermindern
 subi pixnull_add,-1;-2       ;+2 Nullen dem Nullenaddierer hinzufuegen
 mov  pixaus_zlr,pixnull_add;Pixel AUS ( Nullen ) Zaehler neu laden
 rjmp _sk6812_pixmuster    ;Pixelmuster holen und verarbeiten
;
;
;
_pixaus_zlr: 
 dec  pixaus_zlr           ;Pixel AUS ( Nullen ) Zaehler um eins vermindern
_pixaus: 
 clr  a                    ;Pixel ausschalten rjmp _sk6812_ansteuern    
 rjmp _sk6812_ansteuern    ;SK6812_ansteuern
;
;SK6812 Schleife
;
_sk6812_loop: 
 ldi  a,#sk6812_pix_azhl   ;Anzahl der Sk6812 Pixels ( LED's )..
 ;lsl  a                    ;..*2 ergibt automatisch die Anzahl der..
 mov  sk6812_step,a        ;..benoetigten SK6812 Ablaufschritte
 
 clr  pixnull_add          ;(+2 Nullen) Addierer ruecksetzen
_sk6812_pixmuster: 
 ldi  pixmuster,#pixmuster ;Pixelmuster holen

 ldi  a,#pixmusterbit_azhl ;Anzahl der Pixelmusterbits..
 mov  pixmusterbit_zlr,a   ;..im Register Pixelmusterbit-Zaehler speichern
 
 ldi  bit_zlr,1            ;Flag 8 Bits fertig vorbereiten
_last_pixbit:
 cbi  DIN_PORT,din.bit     ;Vom letzten Pixelbit die H-Phase beenden 

 ldi  grbw_byte_zlr,#grbw  ;Byteanzahl pro SK6812-Pixel im Register speichern
  
 tst  pixaus_zlr
 brne _pixaus_zlr
 tst  pixmusterbit_zlr
 brne _dec
 cpi  sk6812_step,0
 brne _sk6812_reset
 ;dec  sk6812_step
 rjmp _pixaus  
 ;rjmp _sk6812_reset
_dec:
 dec  pixmusterbit_zlr
 lsr  pixmuster
 brcc _pixaus
 nop
 mov  a,eins
; 
;SK6812 mit den GRBW-Werten ansteuern 
;
_sk6812_ansteuern: 
 mov  grbw_byte,a          ;Aktuelles GRBW-Byte kopieren
_code_0_oder_1:
 sbi  DIN_PORT,din.bit     ;SK6812 DIN auf High setzen
 lsl  grbw_byte            ;Jeweilisges GRBW-Bit ins Carry schieben..
 brcs _code_1              ;..Bit = 1? Ja -> Code_1 ausfuehren
_code_0:
 lsl  bit_zlr              ;Flag 8 Bits zaehlen schieben
 cbi  DIN_PORT,din.bit     ;SK6812 DIN auf  Low setzen ( H-Phase beenden )
 brcc _code_0_next         ;Letztes Code_0 Bit? NEIN -> springen
 ldi  bit_zlr,1            ;Flag 8 Bits fertig vorbereiten
 dec  grbw_byte_zlr        ;GRBW-Bytezaehler um eins vermindern..
 breq _last_pixbit         ;..letzte Pixelbit? JA -> naechstes Pixel bearbeiten
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 rjmp _sk6812_ansteuern    ;Naechster GRBW-Wert
_code_0_next: 
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 nop                       ;Timing anpassen
 rjmp _code_0_oder_1       ;Pruefen, ob Code_0 oder Code_1 zu erzeugen ist
_code_1:
 lsl  bit_zlr              ;Flag 8 Bits zaehlen schieben
 brcc _code_1_next         ;Letztes Code_1 Bit? NEIN -> springen
 ldi  bit_zlr,1            ;Flag 8 Bits fertig vorbereiten
 dec  grbw_byte_zlr        ;GRBW-Bytezaehler um eins vermindern..
 breq _last_pixbit         ;..letzte Pixelbit? JA -> naechstes Pixel bearbeiten
 nop                       ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;SK6812 DIN auf  Low setzen ( H-Phase beenden )
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 rjmp _sk6812_ansteuern    ;Naechster GRBW-Wert
_code_1_next: 
 sbi  DIN_PORT,din.bit     ;Timing anpassen
 nop                       ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;SK6812 DIN auf  Low setzen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 cbi  DIN_PORT,din.bit     ;Timing anpassen
 rjmp _code_0_oder_1       ;Pruefen, ob Code_0 oder Code_1 zu erzeugen ist
;
;ProgrammLaufAnzeige (PLA) in Gang halten
;
_idle:
 sbrs flag_reg,pla.aktiv    ;Ist die ProgrammLaufAnzeige per Jumper aktiv?
 rjmp _idle_pla_inaktiv     ;Nein -> Springen
 sbr  flag_reg,1<<pla.flg   ;Programmlaufanzeige-Flag quitieren
_idle_pla_inaktiv:
 ;sbi  PLA_PORT,led.pla      ;PLA-LED ausschalten 

 ;sbr  flag_reg,1<<pla.aktiv ;T E S T ###########################################


 rjmp _main                 ;Sprung zum Anfang des Hauptprogramms ( Mainloop )
; 
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;U Beginn der verwendeten Unterprogramme
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
;
.include "UP.inc";Unterprogramme
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
.include "ISR.inc";Interrupt Service Routinen
;
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;D Daten im SRAM ablegen
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;
.DSEG
;_adc_werte:
;.BYTE #adc_azhl          ;Anzahl der Eingelesenen ADC-Werte
 
.EXIT                       ;Ende des Quelltextes
